package application;

import domaine.*;

public class EssaiFibo {
	private static long dureeCalculSansProxy(int valeur) {
		long instant1, instant2, resultat;
		instant1 = System.currentTimeMillis();
		resultat = Fibo.fibo(valeur);
		instant2 = System.currentTimeMillis();
		System.out.print("fibo("+valeur+")="+resultat);
		return instant2 - instant1;
	}
	private static long dureeCalculAvecProxy(int valeur, MemoFibo mf) {
		long instant1, instant2, resultat;
		instant1 = System.currentTimeMillis();
		resultat = mf.fibo(valeur);
		instant2 = System.currentTimeMillis();
		System.out.print("fibo("+valeur+")="+resultat);
		return instant2 - instant1;
	}
	public static void main(String[] args) {
		int valeur = 45;
		long duree;
		System.out.println("______ sans proxy ______");
		System.out.println("on lance le calcul de Fibo("+valeur+") ...");
		duree = dureeCalculSansProxy(valeur);
		System.out.println(" obtenu en "+duree+"ms");
		System.out.println("on relance le calcul de Fibo("+valeur+") ...");
		duree = dureeCalculSansProxy(valeur);
		System.out.println(" obtenu en "+duree+"ms");
		System.out.println("______ avec proxy ______");
		MemoFibo mf = MemoFibo.getInstance();
		System.out.println("on lance le calcul de Fibo("+valeur+") ...");
		duree = dureeCalculAvecProxy(valeur, mf);
		System.out.println(" obtenu en "+duree+"ms");
		System.out.println("on relance le calcul de Fibo("+valeur+") ...");
		duree = dureeCalculAvecProxy(valeur, mf);
		System.out.println(" obtenu en "+duree+"ms");
	}

}
