package domaine;

public class MandataireCompteBancaire {
	private CompteBancaire cpt;
	public MandataireCompteBancaire(int numero) {
		cpt = new CompteBancaire(numero);
		Journal.getInstance().ecrire("Ouverture du compte "+cpt.numero()+".");
	}
	public void deposer(double montant) throws Exception {
		try {
			cpt.deposer(montant);
			Journal.getInstance().ecrire("Dpt de "+montant+" sur le compte "+cpt.numero()+".");
		} catch (Exception e) {
			Journal.getInstance().ecrire("/!\\ "+e.getMessage());
		}
	}
	public void retirer(double montant) throws Exception {
		try {
			cpt.retirer(montant);
			Journal.getInstance().ecrire("Retrait de "+montant+" sur le compte "+cpt.numero()+".");
		} catch (Exception e) {
			Journal.getInstance().ecrire("/!\\ "+e.getMessage());
		}
	}
	public int numero() {
		return cpt.numero();
	}
	public double solde() {
		Journal.getInstance().ecrire("Consultation du solde du compte "+cpt.numero()+".");
		return cpt.solde();
	}
	public String toString() {
		return cpt.toString();
	}
}
