package domaine;

import java.math.RoundingMode;
import java.text.NumberFormat;

public class CompteBancaire {
	private int numero;// Numro du compte.
	private double solde;// montant disponible sur le compte.
	private static NumberFormat nf = null;

	// Constructeur d'un CompteBancaire  partir de son numro.
	public CompteBancaire(int numero) {
		this.numero=numero;
		this.solde=0.0;
	}

	// Mthode qui permet de dposer de l'argent sur le compte.
	public void deposer(double montant) throws Exception {
		if(montant>0.0) {
			solde+=montant;// On ajoute la somme dpose au solde.
		} else {
			throw new Exception("Dpt d'une valeur ngative impossible (compte:"+numero+" depot de "+montant+").");
		}
	}

	// Mthode qui permet de retirer de l'argent sur le compte.
	public void retirer(double montant) throws Exception {
		if(montant>0.0) {
			if(solde>=montant) {
				solde-=montant;// On retranche la somme retire au solde.
			} else {
				throw new Exception("La banque n'autorise pas de dcouvert (compte:"+numero+" solde:"+solde+" retrait de "+montant+").");
			}
		} else {
			throw new Exception("Retrait d'une valeur ngative impossible (compte:"+numero+" retrait de "+montant+").");
		}
	}

	public double solde() {
		return solde();
	}

	public int numero() {
		return numero;
	}

	public String toString() {
		if (nf == null) {
			nf = NumberFormat.getNumberInstance();
			nf.setMinimumIntegerDigits(1);
			nf.setMaximumIntegerDigits(4);
			nf.setGroupingUsed(false);
			nf.setMinimumFractionDigits(2);
			nf.setMaximumFractionDigits(2);
			nf.setRoundingMode(RoundingMode.HALF_UP);
		}
		return "numero:"+numero+" solde:"+nf.format(solde)+"";
	}
}
