package domaine;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

public class Journal {
	private static Journal uniqueInstance;// Stockage de l'unique instance de cette classe.
	private static DateFormat df = null;
	private String texte;// Chaine de caractres reprsentant les messages de log.

	// Constructeur en priv (donc inaccessible  l'extrieur de la classe).
	private Journal() {
		texte = new String();
	}

	// Mthode statique qui sert de pseudo-constructeur (utilisation du mot clef "synchronized" pour le multithread).
	public static synchronized Journal getInstance() {
		if(uniqueInstance==null) {
			uniqueInstance = new Journal();
		}
		return uniqueInstance;
	}

	// Mthode qui permet d'ajouter un message de log.
	public void ecrire(String log) {
		// On ajoute galement la date du message.
		Date d = new Date();
		if (df == null) {
			df = new SimpleDateFormat("dd/MM/yyyy HH'h'mm");
		}
		texte+="["+df.format(d)+"] "+log+"\n";
	}

	// Mthode qui retourne tous les messages du journal.
	public String toString() {
		return texte;
	}
}
